controllers/ArticuloController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Articulo;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;


/**
 * ArticuloController implements the CRUD actions for Articulo model.
 */
class ArticuloController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Articulo models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Articulo::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Articulo model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Articulo model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Articulo();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Articulo model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Articulo model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Articulo model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Articulo the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Articulo::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    

}

controllers/FotoController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Foto;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * FotoController implements the CRUD actions for Foto model.
 */
class FotoController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Foto models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Foto::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Foto model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Foto model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        /*
         * ejemplo de clase para ver lo fácil que es introducir datos
        $model = new Foto();
        $model->id=1;
        $model->nombre="f2.jpg";
        $model->alt="Ejemplo de foto del artículo";
        $model->articulo=1;
        $model->save();
        exit;
        */
        $model = new Foto();

       if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Foto model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
       
       $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }
        
        
        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Foto model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Foto model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Foto the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Foto::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\web\Controller;
use yii\web\Response;
use app\models\Articulo;
use app\models\Foto;
use yii\data\ActiveDataProvider;
use yii\data\Pagination;



class SiteController extends Controller
{
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
        ];
    }
     public function actionIndex()
    {   
         $dataProvider = new ActiveDataProvider([
            'query' => Articulo::find(),
             'pagination'=>[
                 'pageSize'=>1
             ]
        ]);
         
        $datos= Articulo::find()->all();
        return $this->render('index',[
            "dataProvider"=>$dataProvider,
            "articulos"=>$datos,
        ]);
    }
    
    public function actionEjemplo()
    {   
        $datos= Articulo::find()->all();
        return $this->render('index',[
            "articulos"=>$datos,
        ]);
    }

    
    public function actionFotosarticulo()
    {   
        $datos= Articulo::find()->all();
        return $this->render('fotosArticulo',[
            "articulos"=>$datos,
        ]);
    }
    
    public function actionBack(){
    
        return $this->render('back');
    }
        public function actionListar(){
        $listado= Articulo::find();
        $pagination = new Pagination([
            'defaultPageSize' => 1,
            'totalCount' => $listado->count(),
        ]);
        
        $articulos = $listado->offset($pagination->offset)
        ->limit($pagination->limit)
        ->all();
        
        $fotos=Foto::find()->all();
        return $this->render("listado",[
            "datos"=>$articulos,
            "fotos"=>$fotos,
            "paginas"=>$pagination
        ]);
    }

}

views/site/_articulo.php
<?php
use yii\helpers\Html;
?>
<?= 
    $this->render('_campo',[
        "valor"=>$dato->id,
        "etiqueta"=>$dato->getAttributeLabel("id"),
    ]);
?>
<?= 
    $this->render('_campo',[
        "valor"=>$dato->titulo,
        "etiqueta"=>$dato->getAttributeLabel("titulo"),
    ]);
?>
<?= 
    $this->render('_campo',[
        "valor"=>$dato->texto,
        "etiqueta"=>$dato->getAttributeLabel("texto"),
    ]);
?>
   

<?php

//var_dump($dato->fotos);
/*$fotosArticulo=$dato->fotos;*/

foreach($dato->fotos as $v){
    echo Html::img("@web/imgs/".$v->nombre,['class'=>'margen', "width"=>'200px']); 
}
echo '<br>';
   
?>
   
   

views/site/_campo.php
<div class="panel panel-primary">
    <div class="panel-heading"><?= $etiqueta ?></div>
    <div class="panel-body"><?= $valor ?></div>
</div>

views/site/back.php
<?php 
use yii\helpers\Html;
?>
<ul class="nav nav-pills nav-stacked">
 
  <li role="presentation"><?= Html::a('Artículos', ['articulo/index',], ['class' => 'btn btn-info','style'=>'font-size:30px']) ?></li>
  <li role="presentation"><?= Html::a('Fotos', ['foto/index',], ['class' => 'btn btn-info','style'=>'font-size:30px;']) ?></li>
</ul>

views/site/ejemplo.php
<?php
use yii\base\Widget;
use yii\grid\GridView;
use app\models\Foto;
// var_dump($articulos);
/* @var $this yii\web\View */

$this->title = 'Listado';
?>
<div class="site-index">
    <ul>
        <?php 
        foreach($articulos as $articulo){
            echo $this->render('index/_articulo',[
                "datos"=>$articulo, // es como el ejemplo de los autores
            ]);
            /**
             * Del artículo actual quiero ver las fotos
             */
            $fotosArticulo=$articulo->fotos; // es un array de modelos Foto
            
            foreach ($fotosArticulo as $foto){
                echo $this->render("index/_fotos",[
                "datos"=>$foto,
            ]);
            }
            
            
            /*
            $a=$articulo->fotos;
            var_dump($a);
            
            $a=Foto::find()
                    ->where(["articulo"=>$articulo->id])
                    ->all();
            var_dump($a);
             * */
             
        }
        ?>
    </ul>
  
</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/fotosArticulo.php
<?php
use yii\base\Widget;
use yii\grid\GridView;
use app\models\Foto;
// var_dump($articulos);
/* @var $this yii\web\View */

$this->title = 'Listado';
?>
<div class="site-index">
    <ul>
        <?php 
        foreach($articulos as $articulo){
            
            /**
             * Del artículo actual quiero ver las fotos
             */
            $fotosArticulo=$articulo->fotos
                    
                    ; // es un array de modelos Foto
            //var_dump($fotosArticulo);
            foreach ($fotosArticulo as $foto){
               // var_dump($articulo->id);
                echo $this->render("index/_fotos1",[
                "datos"=>$foto,
            ]);
            }
            
            
            /*
            $a=$articulo->fotos;
            //var_dump($a);
            
            $a=Foto::find()
                    ->where(["articulo"=>$articulo->id])
                    ->all();
            //var_dump($a);
             */
             
        }
        ?>
    </ul>
  
</div>

views/site/index.php
<?php
var_dump($articulos);
//echo $articulos->titulo;
foreach ($articulos as $articulo) {
    echo $articulo->titulo;
}

views/site/listado.php
<div>
<h2 class="alert-info alert">listado de artículos</h2>

<?php
echo yii\widgets\LinkPager::widget([
    'pagination' => $paginas,
]);

foreach($datos as $dato){
    echo $this->render('_articulo',[
        "dato"=>$dato,
        "fotos"=>$fotos
    ]);
}
echo yii\widgets\LinkPager::widget([
    'pagination' => $paginas,
]);

?>

</div>